#define shrt 8
#define pwm 9
#define button 13
#define A 2
#define B 3

int buttonState = 0;
float mSpeed = 0;
float wSpeed = 0;
int counter = 0;
volatile long encoderValue = 0;
long previousMillis = 0;
long currentMillis = 0;
int interval = 200;
int revCount = 48;
float rpm = 0;

void setup() {
  // put your setup code here, to run once:
  pinMode(pwm,OUTPUT);
  pinMode(shrt,OUTPUT);
  pinMode(button,INPUT);
  Serial.begin(9600);
  pinMode(A,INPUT);
  pinMode(B,INPUT);
  attachInterrupt(digitalPinToInterrupt(A), updateEncoder, RISING);
  previousMillis = millis();
}

void loop() {
  // put your main code here, to run repeatedly:
  currentMillis = millis();
  if (currentMillis - previousMillis > interval) {
    previousMillis = currentMillis;
    
    rpm = (encoderValue * 300 / revCount);
    
    Serial.print(encoderValue);
    Serial.print(" SPEED: ");
    Serial.print(rpm);
    Serial.println(mSpeed);
    encoderValue = 0;
  }
  buttonState = digitalRead(button);
  if (buttonState == HIGH) {
    mSpeed = map(rpm, 0, 375, 120, 255);
    digitalWrite(shrt, HIGH);
    delay(10);
    analogWrite(pwm, mSpeed);
    Serial.println("Rolling");
  }
  else {
    Serial.println("Button in");
    analogWrite(pwm, 0);
    //delay(20);
    digitalWrite(shrt, LOW);
    Serial.println("Braking");
    //delay(100000);
  }
}

void updateEncoder(){
  if (digitalRead(B) != digitalRead(A)) {
    encoderValue++;
  }
}
