#define shrt 5
#define tr_1 10
#define tr_2 11
#define tr_3 12
#define tr_4 13
#define button 9
#define A 2
#define B 6

int buttonState = 0;
float mSpeed = 0;
bool forward = false;
bool backward = false;
float wSpeed = 0;
int counter = 0;
int currentDir = 1;
int currentStateA;
volatile long encoderValue = 0;
long previousMillis = 0;
long currentMillis = 0;
int interval = 200;
int revCount = 48;
float rpm = 0;

void setup() {
  // put your setup code here, to run once:
  pinMode(tr_1,OUTPUT);
  pinMode(tr_2,OUTPUT);
  pinMode(tr_3,OUTPUT);
  pinMode(tr_4,OUTPUT);
  pinMode(shrt,OUTPUT);
  pinMode(button,INPUT);
  Serial.begin(9600);
  pinMode(A,INPUT);
  pinMode(B,INPUT);
  attachInterrupt(digitalPinToInterrupt(A), updateEncoder, RISING);
  previousMillis = millis();

}

void loop() {
  // put your main code here, to run repeatedly:
  currentMillis = millis();
  if (currentMillis - previousMillis > interval) {
    previousMillis = currentMillis;
    
    rpm = (encoderValue * 300 / revCount);
    
    Serial.print(encoderValue);
    Serial.print(" SPEED: ");
    Serial.println(rpm);
    encoderValue = 0;
  }
  buttonState = digitalRead(button);
  if (buttonState == HIGH) {
    if (currentDir == 0){
      if (forward == false){
        forwardDir();
      }
      mSpeed = map(rpm, 0, 375, 0, 255);
      analogWrite(tr_1, mSpeed);
      Serial.println("Button in, forward");
      delay(10);
    }
    else if (currentDir == 1){
      if (backward == false){
        backwardDir();
      }
      mSpeed = map(rpm, 0, 375, 0, 255);
      analogWrite(tr_2, mSpeed);
      Serial.println("Button in, backward");
      delay(10);
    }
  }
  else {
    if (currentDir == "Forward" && rpm > 120){
      if (backward == false){
        backwardDir();
      }
      mSpeed = 0;
      analogWrite(tr_2, mSpeed);
      //Serial.println("Brake forward");
      delay(10);
    }
    else if (currentDir == "Backward" && rpm > 120){
      if (forward == false){
        forwardDir();
      }
      mSpeed = 0;
      analogWrite(tr_1, mSpeed);
      //Serial.println("Brake backward");
      delay(10);
    }
    else{
      analogWrite(tr_1, 0);
      analogWrite(tr_2, 0);
      digitalWrite(tr_3, LOW);
      digitalWrite(tr_4, LOW);
      delay(10);
      digitalWrite(shrt, HIGH);
      digitalWrite(tr_4, HIGH);
      Serial.println("Brake standing");
    }
  }
}

void forwardDir () {
  analogWrite(tr_1, 0);
  analogWrite(tr_2, 0);
  digitalWrite(tr_3, LOW);
  digitalWrite(tr_4, LOW);
  digitalWrite(shrt, LOW);
  delay(20);
  //analogWrite(tr_1, 255);
  digitalWrite(tr_4, HIGH);
  forward = true;
  backward = false;
  Serial.println("forward");
}

void backwardDir () {
  analogWrite(tr_1, 0);
  analogWrite(tr_2, 0);
  digitalWrite(tr_3, LOW);
  digitalWrite(tr_4, LOW);
  digitalWrite(shrt, LOW);
  delay(20);
  //analogWrite(tr_2, 255);
  digitalWrite(tr_3, HIGH);
  backward = true;
  forward = false;
  Serial.println("backward");
}

void updateEncoder(){
  if (digitalRead(B) != digitalRead(A)) {
    currentDir = 0;
  }
  else {
    currentDir = 1;
  }
  encoderValue++;
}
